// farmingRevamp_JS | EXPERIMENTS; Script API
import { world, EquipmentSlot } from "@minecraft/server";

world.beforeEvents.playerBreakBlock.subscribe (event => {

  const { player, block } = event; const dimension = player.dimension; const awardXP = Math.floor(Math.random() * 2) + 1;
  const isCrop = block.hasTag("minecraft:crop"); const cropGrowth = block.permutation.getState("growth") || 0;
  const mainHand = player.getComponent("minecraft:equippable").getEquipment(EquipmentSlot.Mainhand);

// AUTOMATICALLY PLANT CROPS ONCE HARVESTED
  function autoCrop (dimension, blockType, y, x, z) {
    dimension.runCommandAsync(`setblock ${x} ${y} ${z} ${blockType}`);
  }

  if (isCrop && (cropGrowth === 7)) {
// Award XP
    if (mainHand?.typeId.endsWith("_hoe")) {
      dimension.runCommandAsync(`summon xp_orb ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`); // summon XP Orb above Farmland
    }
    if (mainHand?.typeId === ("minecraft:netherite_hoe")) {
      for (let xp = 0; xp < awardXP; xp++) {
        dimension.runCommandAsync(`summon xp_orb ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`); // summon XP Orb above Farmland
      }
    }
// Auto Plant
    if (mainHand?.typeId === ("minecraft:golden_hoe")) {
      autoCrop(dimension, block.typeId, block.location.y, block.location.x, block.location.z)
      event.player.runCommandAsync(`particle minecraft:villager_happy ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`) // particle above Farmland
    // Consumes seeds or crop
      if (block?.typeId === ("minecraft:wheat")) event.player.runCommandAsync(`clear @p minecraft:wheat_seeds 0 1`);
      if (block?.typeId === ("minecraft:beetroot")) event.player.runCommandAsync(`clear @p minecraft:beetroot_seeds 0 1`);
      if (block?.typeId === ("minecraft:carrots")) event.player.runCommandAsync(`clear @p minecraft:carrot 0 1`);
      if (block?.typeId === ("minecraft:potatoes")) event.player.runCommandAsync(`clear @p minecraft:potato 0 1`);
    }
  }

});
// REVAMPED | Soil & Toil | LieutSavg99